#include <Windows.h>
#include <stdio.h>

typedef enum _HARDERROR_RESPONSE {
	ResponseReturnToCaller,
	ResponseNotHandled,
	ResponseAbort,
	ResponseCancel,
	ResponseIgnore,
	ResponseNo,
	ResponseOk,
	ResponseRetry,
	ResponseYes
} HARDERROR_RESPONSE, *PHARDERROR_RESPONSE;

typedef enum _HARDERROR_RESPONSE_OPTION {
	OptionAbortRetryIgnore,
	OptionOk,
	OptionOkCancel,
	OptionRetryCancel,
	OptionYesNo,
	OptionYesNoCancel,
	OptionShutdownSystem
} HARDERROR_RESPONSE_OPTION, *PHARDERROR_RESPONSE_OPTION;

typedef struct _UNICODE_STRING {
	USHORT  Length;
	USHORT  MaximumLength;
	PWSTR  Buffer;
} UNICODE_STRING, *PUNICODE_STRING;

typedef BOOL(__stdcall *typeFunRtlAdjustPrivilege)(ULONG, BOOL, BOOL, PBOOLEAN);
typedef void(__stdcall *typeFunNtRaiseHardError)(ULONG, ULONG, PUNICODE_STRING, PVOID, HARDERROR_RESPONSE_OPTION, OUT PHARDERROR_RESPONSE);
typedef BOOL(__stdcall *typeCsrGetProcessId)(void);
typedef void(__stdcall *typeFunNtSetInformationProcess)(HANDLE, ULONG, PVOID, ULONG);
typedef void(__stdcall *typeFunSetInformatioinThread)(HANDLE, ULONG, PVOID, ULONG);
typedef void(__cdecl *typeSetProcessIsCritical)(BOOLEAN, PBOOLEAN, BOOLEAN);
typedef void(__cdecl *typeFunSetThreadIsCritical)(BOOLEAN, PBOOLEAN, BOOLEAN);

const ULONG SE_SHUTDOWN_PRIVILEGE = 19;
const ULONG SE_DEBUG_PRIVILEGE = 20;
const int ProcessBreakOnTermination = 0x1D;
const int ThreadBreakOnTermination = 0x12;

BOOL BlueScreenByRaiseHardError();
BOOL BlueScreenByTerminateProcess();
BOOL BlueScreenByNtSetInformationProcess();
BOOL BlueScreenBySetInformationThread();
BOOL BlueScreenByRtlSetProcessIsCritical();
BOOL BlueScreenByRtlSetThreadIsCritical();

typeFunRtlAdjustPrivilege pfnRtlAdjustPrivilege = NULL;

int main(int argc, char* argv[])
{
	pfnRtlAdjustPrivilege = (typeFunRtlAdjustPrivilege)GetProcAddress(GetModuleHandle(TEXT("ntdll")), "RtlAdjustPrivilege");

	int choice = 0;
	printf("1-6: ");
	scanf_s("%d", &choice);

	switch (choice)
	{
	case 1:
		BlueScreenByRaiseHardError();
		break;
	case 2:
		BlueScreenByTerminateProcess();
		break;
	case 3:
		BlueScreenByNtSetInformationProcess();
		break;
	case 4:
		BlueScreenBySetInformationThread();
		break;
	case 5:
		BlueScreenByRtlSetProcessIsCritical();
		break;
	case 6:
		BlueScreenByRtlSetThreadIsCritical();
		break;
	default:
		break;
	}

	return 0;
}

BOOL AdjustPrivilege(ULONG uPri)
{
	if (pfnRtlAdjustPrivilege)
	{
		BOOLEAN bEnable;
		if (pfnRtlAdjustPrivilege(uPri, TRUE, FALSE, &bEnable) == 0)
		{
			return TRUE;
		}
	}
	else
	{
		printf("failed to get function rtladjustprivilege. \n");
	}

	return FALSE;
}

BOOL BlueScreenByRaiseHardError()
{
	BOOL bRet = FALSE;

	HARDERROR_RESPONSE response = ResponseYes;
	HARDERROR_RESPONSE_OPTION responseOption = OptionShutdownSystem;

	typeFunNtRaiseHardError pfnNtRaiseHardError = (typeFunNtRaiseHardError)
		GetProcAddress(GetModuleHandle(TEXT("ntdll")), "NtRaiseHardError");

	if (AdjustPrivilege(SE_SHUTDOWN_PRIVILEGE))
	{
		pfnNtRaiseHardError(0xC0000217, 0, 0, 0, responseOption, &response);
		bRet = TRUE;
	}

	return bRet;
}

BOOL BlueScreenByTerminateProcess()
{
	BOOL bRet = FALSE;

	typeCsrGetProcessId pfnCsrGetProcessId = (typeCsrGetProcessId)GetProcAddress(GetModuleHandleW(TEXT("ntdll")), "CsrGetProcessId");

	if (AdjustPrivilege(SE_DEBUG_PRIVILEGE))
	{
		HANDLE hProcess;
		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pfnCsrGetProcessId());
		TerminateProcess(hProcess, 0);
		bRet = TRUE;
	}
	return bRet;
}

BOOL BlueScreenByNtSetInformationProcess()
{
	BOOL bRet = FALSE;

	typeFunNtSetInformationProcess pfnNtSetInformationProcess = (typeFunNtSetInformationProcess)
		GetProcAddress(GetModuleHandleW(TEXT("ntdll")), "NtSetInformationProcess");
	
	if (AdjustPrivilege(SE_DEBUG_PRIVILEGE))
	{
		ULONG uTmp = 1;
		pfnNtSetInformationProcess(GetCurrentProcess(), ProcessBreakOnTermination, &uTmp, sizeof(ULONG));
		ExitProcess(0);
		bRet = TRUE;
	}
	
	return bRet;
}

BOOL BlueScreenBySetInformationThread()
{
	BOOL bRet = FALSE;

	typeFunSetInformatioinThread pfnNtSetInformationThread = (typeFunSetInformatioinThread)
		GetProcAddress(GetModuleHandleW(TEXT("ntdll")), "NtSetInformationThread");

	if (AdjustPrivilege(SE_DEBUG_PRIVILEGE))
	{
		ULONG uTmp = 1;
		pfnNtSetInformationThread(GetCurrentThread(), ThreadBreakOnTermination, &uTmp, sizeof(ULONG));
		ExitProcess(0);
		bRet = TRUE;
	}

	return bRet;
}

BOOL BlueScreenByRtlSetProcessIsCritical()
{
	BOOL bRet = FALSE;

	typeSetProcessIsCritical pfnRtlSetProcessIsCritical = (typeSetProcessIsCritical)
		GetProcAddress(GetModuleHandleW(TEXT("ntdll")), "RtlSetProcessIsCritical");

	if (AdjustPrivilege(SE_DEBUG_PRIVILEGE))
	{
		pfnRtlSetProcessIsCritical(TRUE, NULL, FALSE);
		ExitProcess(0);
		bRet = TRUE;
	}
	
	return bRet;
}

BOOL BlueScreenByRtlSetThreadIsCritical()
{
	BOOL bRet = FALSE;

	typeFunSetThreadIsCritical pfnRtlSetThreadIsCritical = (typeFunSetThreadIsCritical)
		GetProcAddress(GetModuleHandleW(TEXT("ntdll")), "RtlSetThreadIsCritical");
		
	if (AdjustPrivilege(SE_DEBUG_PRIVILEGE))
	{
		pfnRtlSetThreadIsCritical(TRUE, NULL, FALSE);
		ExitProcess(0);
		bRet = TRUE;
	}

	return bRet;
}